<?php
////////////////////////////////////////////////////////////////
//¤
// File:      FAST 4.0 (First Automatic Server for Trackmania)
// Web:       
// Date:      07.07.2013
// Author:    Gilles Masson
// 
////////////////////////////////////////////////////////////////
global $_tm_db,$_tm_db_defaults,$_XmlrpcDB_bad_retry_timeout;
//
// 
registerPlugin('database',8);


////////////////////////////////////////////////////////////////
/* Note: 
   This plugin need to add <dedimaniacode> in the <masterserver_account> part
   of the dedicated config file. ie something like :
   --------------------------------------------------------
     <masterserver_account>
       ............
       <dedimaniacode>YourTMdedicatedDedimaniaCode</dedimaniacode>
     </masterserver_account>
   --------------------------------------------------------
   The dedimaniacode for your server login can be found on :

        http://dedimania.net/tm2stats/?do=register
*/
////////////////////////////////////////////////////////////////



// how many seconds before retrying connection
$_XmlrpcDB_bad_retry_timeout = 1200;


// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!! modify those values in fast_config_xx.php !!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

$_tm_db_defaults = array('Name' => 'Dedimania',
												 'Tag' => 'Dm',
												 'NameForTrack' => 'Dedimania',
												 'UrlForTrack' => '',
												 'SaveRecords' => true,
												 'ShowRecords' => 5,
												 'ShowNewRecordToAll' => 10,
												 'ShowNewRecordToAllRatio' => 0.5,
												 'ShowNewRecordToPlayer' => 80,
);


//------------------------------------------
// Init : 
//------------------------------------------
function databaseInit(){
	global $_debug,$_webaccess,$_locale,$_tm_db,$_FASTver,$_DedConfig,$_tm_db_defaults,$database_ChallengeInfo,$database_GameInfos,$database_lastsent,$_currentTime,$_Game,$_FAST_tool,$_DisabledPlugins,$_dbmodelist,$_database_store_best_vreplay;

	$_dbmodelist[SCRIPT] = '';
	$_dbmodelist[ROUNDS] = 'Rounds';
	$_dbmodelist[TA] = 'TA';
	$_dbmodelist[TEAM] = 'Rounds';
	$_dbmodelist[LAPS] = 'TA';
	$_dbmodelist[CUP] = 'Rounds';
	$_dbmodelist[STUNTS] = '';

	if(!isset($_database_store_best_vreplay))
		$_database_store_best_vreplay = false;

	$datas = array();
	// get standard Dedimania database config
	if(!isset($_DisabledPlugins['database.dedimania.xml.txt']))
		$datas = loadLocaleFile('./plugins/database.dedimania.xml.txt');
	// get custom database config (for Dedimania overrules and/or custom database) 
	if(!isset($_DisabledPlugins['database.custom.xml.txt'])){
		$data2 = loadLocaleFile('./plugins/database.custom.xml.txt');
		if($data2)
			array_merge_deep($datas,$data2);

		elseif(!isset($_DisabledPlugins['custom'])){
			$data2 = loadLocaleFile('./custom/database.custom.xml.txt');
			if($data2)
				array_merge_deep($datas,$data2);
		}
	}

	// make database info array
	$_tm_db = array();
	$tm_db_num = 0;
	if(isset($datas['fast']['database']) && is_array($datas['fast']['database'])){

		foreach($datas['fast']['database'] as $key => &$dbdatas){

			if(is_array($dbdatas) && isset($dbdatas['url'])){
				$_tm_db[$tm_db_num]['Url'] = $dbdatas['url'];
				$_tm_db[$tm_db_num]['ConnectName'] = $dbdatas['url'];

				if(isset($dbdatas['name']))
					$_tm_db[$tm_db_num]['Name'] = sprintf($dbdatas['name'],$_Game);
				else
					$_tm_db[$tm_db_num]['Name'] = $_tm_db_defaults['Name'];

				if(isset($dbdatas['tag']))
					$_tm_db[$tm_db_num]['Tag'] = sprintf($dbdatas['tag'],$_Game);
				else
					$_tm_db[$tm_db_num]['Tag'] = $_tm_db_defaults['Tag'];

				if(isset($dbdatas['name_for_track']))
					$_tm_db[$tm_db_num]['NameForTrack'] = $dbdatas['name_for_track'];
				else
					$_tm_db[$tm_db_num]['NameForTrack'] = $_tm_db_defaults['NameForTrack'];

				if(isset($dbdatas['url_for_track']))
					$_tm_db[$tm_db_num]['UrlForTrack'] = $dbdatas['name_for_track'];
				else
					$_tm_db[$tm_db_num]['UrlForTrack'] = $_tm_db_defaults['NameForTrack'];

				if(isset($dbdatas['welcome_tag']))
					$_tm_db[$tm_db_num]['WelcomeTag'] = $dbdatas['welcome_tag'];

				if(isset($dbdatas['show_records']))
					$_tm_db[$tm_db_num]['ShowRecords'] = $dbdatas['show_records']+0;
				else
					$_tm_db[$tm_db_num]['ShowRecords'] = $_tm_db_defaults['ShowRecords'];

				if(isset($dbdatas['show_new_record_to_all']))
					$_tm_db[$tm_db_num]['ShowNewRecordToAll'] = $dbdatas['show_new_record_to_all']+0;
				else
					$_tm_db[$tm_db_num]['ShowNewRecordToAll'] = $_tm_db_defaults['ShowNewRecordToAll'];

				if(isset($dbdatas['show_new_record_to_all_ratio']))
					$_tm_db[$tm_db_num]['ShowNewRecordToAllRatio'] = $dbdatas['show_new_record_to_all_ratio']+0;
				else
					$_tm_db[$tm_db_num]['ShowNewRecordToAllRatio'] = $_tm_db_defaults['ShowNewRecordToAllRatio'];

				if(isset($dbdatas['show_new_record_to_player']))
					$_tm_db[$tm_db_num]['ShowNewRecordToPlayer'] = $dbdatas['show_new_record_to_player']+0;
				else
					$_tm_db[$tm_db_num]['ShowNewRecordToPlayer'] = $_tm_db_defaults['ShowNewRecordToPlayer'];

				if(isset($dbdatas['top1_replay_url']) && $dbdatas['top1_replay_url'] != '' &&
					 strlen($dbdatas['top1_replay_url']) > 8 && strncmp('http://',$dbdatas['top1_replay_url'],7) == 0)
					$_tm_db[$tm_db_num]['Top1ReplayUrl'] = $dbdatas['top1_replay_url'];

				$_tm_db[$tm_db_num]['top1time'] = -1;
				
				$tm_db_num++;
			}else
				console("No Url specified in <fast><database><$key>, ignoring it.");
		}
	}
	//if($_debug>8) debugPrint("databaseInit - _locale",$_locale);
	//if($_debug>8) debugPrint("databaseInit - datas",$datas);
	if($_debug>3) debugPrint("databaseInit - _tm_db",$_tm_db);


	// set connection information and test...
	for($i=0; $i < count($_tm_db); $i++){
		$tmdb = &$_tm_db[$i];
		//debugPrint("databaseInit - _tm_db[$i]",$_tm_db[$i]);
			
		$_tm_db[$i]['MaxRecords'] = $_tm_db[$i]['ShowRecords'];
		if($_tm_db[$i]['MaxRecords'] < $_tm_db[$i]['ShowNewRecordToAll'])
			$_tm_db[$i]['MaxRecords'] = $_tm_db[$i]['ShowNewRecordToAll'];
		if($_tm_db[$i]['MaxRecords'] < $_tm_db[$i]['ShowNewRecordToPlayer'])
			$_tm_db[$i]['MaxRecords'] = $_tm_db[$i]['ShowNewRecordToPlayer'];
			
		$tmdb['Waitreply'] = false;

		console("************* (db.$i) *************");
		databaseTryConnect($i);
		console("------------- (db.$i) -------------\n");
	}


	$database_ChallengeInfo = array();
	$database_GameInfos = array();
	$database_lastsent = $_currentTime;


	registerCommand('cp','/cp [-d] ideal|best|1|2|etc. : select the checkpoints list used for live time gaps (-d to show in chat the time between cps).');

}

//------------------------------------------
function databaseTryConnect($i){
	global $_debug,$_tm_db,$_webaccess,$_XmlrpcDB_bad_retry_timeout,$_Game,$_Version,$_FAST_tool,$_FAST_toolversion,$_FASTver,$_DedConfig,$_ServerInfos,$_ServerPackMask,$_is_relay;
	if(!isset($_tm_db[$i]))
		return;
	$tmdb =& $_tm_db[$i];
	$time = time();

	if(!isset($tmdb['XmlrpcDB']) && 
		 (!isset($tmdb['XmlrpcDBbadTime']) || ($time-$tmdb['XmlrpcDBbadTime']) > $_XmlrpcDB_bad_retry_timeout)){

		$url = $tmdb['Url'];

		console("*** Dataserver connection on ".stripColors($tmdb['Name'])." ...\n*****");

		console2("* Try connection on ".$url." ...");
		$xmlrpcdb = new XmlrpcDB($_webaccess,$url);

		if(!isset($_DedConfig['dedimaniacode'])){
			console2("\n\n==========================================================================\n"
							 ."--------------------------------------------------------------------------\n\n"
							 ."Records database: <dedimaniacode> is missing in server configuration file !\n"
							 ."Please add it within <masterserver_account> part, ie something like:\n\n"
							 ."  <masterserver_account>\n"
							 ."    ........\n"
							 ."    <dedimaniacode>your_server_dedimania_code</dedimaniacode>\n"
							 ."  </masterserver_account>\n\n"
							 ."You can register and get your server login dedimaniacode on:\n"
							 ."  http://dedimania.net/tm2stats/?do=register\n\n"
							 ."--------------------------------------------------------------------------\n"
							 ."==========================================================================\n\n");
		}else if(strlen($_DedConfig['dedimaniacode']) < 5  || $_DedConfig['dedimaniacode'] == 'your_server_dedimania_code'){
			console2("\n\n==========================================================================\n"
							 ."--------------------------------------------------------------------------\n\n"
							 ."Records database: the <dedimaniacode> is wrong ({$_DedConfig['dedimaniacode']}) !\n\n"
							 ."You can register and get your server login dedimaniacode on:\n"
							 ."  http://dedimania.net/tm2stats/?do=register\n\n"
							 ."--------------------------------------------------------------------------\n"
							 ."==========================================================================\n\n");

		}else if(!isset($tmdb['SessionId'])){
			// first time: open session
			//print_r($_DedConfig);
			//print_r($_ServerInfos);
			$srvconnect = array('Game'=>'TM2','Login'=>$_DedConfig['login'],'Code'=>$_DedConfig['dedimaniacode'],'Path'=>$_ServerInfos['Path'],'Packmask'=>$_ServerPackMask,
													 'ServerVersion'=>$_Version['Version'],'ServerBuild'=>$_Version['Build'],'Tool'=>$_FAST_tool,'Version'=>$_FAST_toolversion);
			$response = $xmlrpcdb->RequestWait('dedimania.OpenSession',$srvconnect);

			//debugPrint("databaseInit - response",$response['Data']);
			//debugPrint("databaseInit - response",$response);
		
			if($response === false){
				console2("  !!!!!!\n  !!!!!! Error bad database response !\n  !!!!!!");
				
			}elseif(isset($response['Data']['params']['SessionId']) && $response['Data']['params']['SessionId'] != ''){
				$tmdb['XmlrpcDB'] = $xmlrpcdb;
				$tmdb['SessionId'] = $response['Data']['params']['SessionId'];
				$tmdb['Events'] = array();
				$tmdb['Waitreply'] = false;
				$tmdb['ConnectName'] = $response['Headers']['server'][0];
				console2("  Connection and status ok, session opened ! ({$response['Headers']['server'][0]})");
				
				if(isset($response['Data']['errors']) && databaseIsError($response['Data']['errors'])) 
					debugPrint("  !!!!!!\n  !!!!!! ... with some authenticate warning: ",$response['Data']['errors']);
				
			}elseif(isset($response['Data']['errors'])){
				
				console2("  !!!!!!\n  !!!!!! Connection Error !!!!!! ({$response['Headers']['server'][0]})\n".$response['Data']['errors']."\n  !!!!!!");
				//if($_debug>2) debugPrint("databaseInit - response",$response);
				
			}elseif(!isset($response['Code'])){
				console2("  !!!!!!\n  !!!!!! Error no database response (".$url.")\n  !!!!!!");
				//if($_debug>2) debugPrint("databaseInit - response",$response);
				
			}else{
				console2("  !!!!!!\n  !!!!!! Error bad database response or contents ({$response['Headers']['server'][0]}) (".$response['Code'].",".$response['Reason'].")\n  !!!!!!");
				if($_debug>0){
					if($response['Code'] == 200)
						debugPrint("databaseInit - response[Message]",$response['Message']);
					elseif($response['Code'] != 404) 
					debugPrint("databaseInit - response",$response);
				}
				
			}
		}

		if(isset($tmdb['XmlrpcDB']))
			return;

		$tmdb['XmlrpcDBbadTime'] = $time;
	}

}


//------------------------------------------
// StartToServe : 
//------------------------------------------
function databaseStartToServe(){
	global $debug,$FASTver,$_tm_db;

}


//--------------------------------------------------------------
// EndResult : good place to try to reconnect to database if needed...
//--------------------------------------------------------------
function databaseEndResult_Post($event){
	global $_debug,$_tm_db;
	if($_debug>3) console("database.Event_Post[$event]()");

	// try reconnect if in error
	for($i=0; $i < count($_tm_db); $i++){
		$tmdb =& $_tm_db[$i];

		// test database if ok
		if(isset($tmdb['XmlrpcDB'])){
			if($tmdb['XmlrpcDB']->isBad()){
				// will retry, if bad state more than 5 min old
				if($tmdb['XmlrpcDB']->badTime() > 300){
					console("DB _tm_db[$i]: retry to send...");
					$tmdb['XmlrpcDB']->retry();
				}
			}
		}else{
			// make a delayed databaseTryConnect($i)
			addEventDelay(1000,'Function','databaseTryConnect',$i);
		}
	}
}


//------------------------------------------
// Everysecond : send requests
//------------------------------------------
function databaseEverysecond_Post($event,$seconds){
	global $_debug,$_tm_db,$database_lastsent,$_currentTime,$_XmlrpcDB_bad_retry_timeout,$_players_actives;
	if($_debug>6) console("database.Event[$event]($seconds)");

	// every 3.5 min after BeginRace or EndRace, update DB infos
	if($database_lastsent+210000 < $_currentTime){
		database_AnnonceToDB();
	}

	// really send the requests to databases after all other events
	for($i = 0; $i < count($_tm_db); $i++){
		$tmdb = &$_tm_db[$i];
		// test database if ok
		if(isset($tmdb['XmlrpcDB'])){

			if($tmdb['XmlrpcDB']->isBad()){
				// avoid waiting with a lost connection
				$tmdb['Waitreply'] = false;
				// will retry, after 30min of bad state without player
				if(($_players_actives <= 1) && ($tmdb['XmlrpcDB']->badTime() > $_XmlrpcDB_bad_retry_timeout)){
					console("DB _tm_db[$i]: retry to send...");
					$tmdb['XmlrpcDB']->retry();
				}
				
			}else{
				$response = $tmdb['XmlrpcDB']->sendRequests();
				if($response == false){
					console("DB _tm_db[$i] have consecutive connection errors !");
					
				}
			}
		}elseif($_players_actives <= 0){
			databaseTryConnect($i);
		}
	}
}		


//------------------------------------------
// PlayerConnect : 
//------------------------------------------
function databasePlayerConnect($event,$login){
	global $_debug,$_tm_db,$_players,$_Game,$_is_relay;
  if(!is_string($login))
    $login = ''.$login;
	if($_debug>2) console("database.Event[$event]('$login')");

	if(isset($_players[$login]) && !$_players[$login]['Relayed']){

		//if($_debug>2) debugPrint("databasePlayerConnect - PlayerInfo",$_players[$login]['PlayerInfo']);
		if($_debug>5) debugPrint("databasePlayerConnect - _player[$login]",$_players[$login]);
	
		$pinfo = database_mkPlayerInfo($login);

		if(is_LAN_login($login))
			return;	// local and not connected player, not accepted for records

		for($i=0; $i < count($_tm_db); $i++){
			$tmdb = &$_tm_db[$i];
			// if database if ok
			if(isset($tmdb['XmlrpcDB']) && !$tmdb['XmlrpcDB']->isBad()){
		
				// set defaults for player
				if(!isset($tmdb['Players'][$login]['MaxRank']))
					$tmdb['Players'][$login] = array('Login'=>$login,'MaxRank'=>20,'Banned'=>false,'OptionsEnabled'=>0,'Options'=>'');
				
				$callback = array('databasePlayerConnect_DB',$login,$i);
				$tmdb['XmlrpcDB']->addRequest($callback, 'dedimania.PlayerConnect',$tmdb['SessionId'],
																			$login,$pinfo['NickName'], 
																			$pinfo['Path'],$pinfo['IsSpec']);
				// dedimania.PlayerConnect(sring SessionId, string Login, string Nickname, string Path, boolean IsSpec)

				if($_debug>2){ // show dedimania.PlayerArrive sent infos...
					$req = array('dedimania.PlayerConnect',$tmdb['SessionId'],
											 $login,$pinfo['NickName'], 
											 $pinfo['Path'],$pinfo['IsSpec']);
					debugPrint("databasePlayerConnect - $i - $login - addRequest - req",$req);
				}

				// update nickname in records
				if($_players[$login]['NickName'] != ''){

					if(isset($tmdb['Challenge']['Records'])){
						foreach($tmdb['Challenge']['Records'] as &$rec){
							if($rec['Login'] == $login){
								$rec['NickName'] = tm_substr($_players[$login]['NickName']);
								$rec['NickDraw'] = htmlspecialchars(tm_substr(stripColors($rec['NickName']),0,13),ENT_QUOTES,'UTF-8');
								break;
							}
						}
					}
				}


			}
		}
	}
}


function databasePlayerConnect_DB($response,$login,$tm_db_n){
	global $_debug,$_tm_db,$_players;
	if(!is_string($login))
		$login = ''.$login;

	if(!dedimaniaCheckCBerror($response,'dedimaniaPlayerConnect_CB'))
		return;

	if(is_LAN_login($login))
		return;

	if(!isset($_players[$login])){
		if($_debug>0) console("databasePlayerConnect_DB - _players[$login] does not exist !");

	}elseif(isset($response['Data']['params']['Login']) && $response['Data']['params']['Login'] == $login){
		$tmdb['Players'][$login]['Login'] = $response['Data']['params']['Login'];
		$tmdb['Players'][$login]['MaxRank'] = $response['Data']['params']['MaxRank'];
		$tmdb['Players'][$login]['Banned'] = $response['Data']['params']['Banned'];
		$tmdb['Players'][$login]['OptionsEnabled'] = $response['Data']['params']['OptionsEnabled'];
		$tmdb['Players'][$login]['Options'] = $response['Data']['params']['Options'];
		
		if($_debug>2) console("databasePlayerConnect_DB({$login},{$tm_db_n}):: response: ".print_r($response['Data']['params'],true));
		if($_debug>1) console("databasePlayerConnect_DB({$login},{$tm_db_n}):: Players[{$login}]: ".print_r($tmdb['Players'][$login],true));

		insertEvent('PlayerArrive',$tm_db_n,$login);
		if($_debug>4) debugPrint("databasePlayerConnect_DB - response",$response['Data']);
	}
}


//------------------------------------------
// PlayerArrive : 
//------------------------------------------
function databasePlayerArrive($event,$tm_db_n,$login){
	global $_players;
	if(!isset($_players[$login]))
		dropEvent();
}


//------------------------------------------
// PlayerRecord : 
//------------------------------------------
function databasePlayerRecord($event,$tm_db_n,$login,$time,$rank,$old_time,$old_rank,$ChallengeInfo,$GameInfos){
	global $_players;
	if(!isset($_players[$login]))
		dropEvent();
}


//------------------------------------------
// PlayerDisconnect : 
//------------------------------------------
function databasePlayerDisconnect($event,$login){
	global $_debug,$_tm_db,$_players,$_Game,$_is_relay;
	if(!isset($_players[$login]['Login']))
		return;
  if(!is_string($login))
    $login = ''.$login;
	if($_debug>2) console("database.Event[$event]('$login')");

	if($_players[$login]['Relayed'])
		return;

	if(is_LAN_login($login))
		return;

	for($i=0; $i < count($_tm_db); $i++){
		$tmdb =& $_tm_db[$i];
		// if database if ok
		if(isset($tmdb['XmlrpcDB']) && !$tmdb['XmlrpcDB']->isBad()){

				$tmdb['XmlrpcDB']->addRequest(null,'dedimania.PlayerDisconnect',$tmdb['SessionId'],$login,''); 
			// dedimania.PlayerDisconnect(string SessionId, string Login, string ToolOption)
		}
	}
}		


//------------------------------------------
// BeginChallenge : 
//------------------------------------------
function databaseBeginChallenge($event,$ChallengeInfo,$GameInfos){
	global $_debug,$_tm_db,$_Game,$_ServerOptions,$database_ChallengeInfo,$database_GameInfos,$database_lastsent,$_currentTime,$_BestChecks,$_BestPlayersChecks,$_BestChecksName,$_IdealChecks,$_dbmodelist,$database_GameInfos,$database_lastsent,$_currentTime,$database_race_time;

	if($_debug>4) debugPrint("database.Event[$event]('".stripColors($ChallengeInfo['Name'])."')",$ChallengeInfo);

	$database_lastsent = $_currentTime;
	$database_race_time = $_currentTime;
	$database_GameInfos = $GameInfos;

	$database_ChallengeInfo = $ChallengeInfo;
	$database_GameInfos = $GameInfos;
	$players = database_mkPlayers();
	$_BestChecks = array();
	$_BestChecksName = 'Top$bb01';
	$_BestPlayersChecks = array();
	$_IdealChecks = array(-1=>array());

	if(isset($ChallengeInfo['UId'])){
		if($_debug>1) console("database.Event[$event]({$ChallengeInfo['UId']},'".stripColors($ChallengeInfo['Name'])."',{$ChallengeInfo['Environnement']},{$ChallengeInfo['Author']})");

		$serverInfos = database_mkServerInfos();

		for($i=0; $i < count($_tm_db); $i++){
			$tmdb =& $_tm_db[$i];
			// if database if ok
			if(isset($tmdb['XmlrpcDB'])){
				$tmdb['Events'] = array();
				$tmdb['Challenge'] = array();
				$tmdb['top1time'] = -1;

				if(!$tmdb['XmlrpcDB']->isBad()){

					//debugPrint('databaseBeginChallenge - ServerOptions',$_ServerOptions);
					//debugPrint('databaseBeginChallenge - ChallengeInfo',$ChallengeInfo);
					//debugPrint('databaseBeginChallenge - GameInfos',$GameInfos);
					
					// race inits
					$callback = array('databaseBeginChallenge_DB',$i,$ChallengeInfo); 

					$tmdb['XmlrpcDB']->addRequest($callback, 
																				'dedimania.GetChallengeRecords',$tmdb['SessionId'],
																				array('UId'=>$ChallengeInfo['UId'],
																							'Name'=>tm_substr($ChallengeInfo['Name']),
																							'Environment'=>$ChallengeInfo['Environnement'],
																							'Author'=>tm_substr($ChallengeInfo['Author']),
																							'NbCheckpoints'=>$ChallengeInfo['NbCheckpoints'],
																							'NbLaps'=>$ChallengeInfo['NbLaps']),
																				$_dbmodelist[$GameInfos['GameMode']],
																				$serverInfos,
																				$players);
					// dedimania.GetChallengeRecords(string SessionId, struct MapInfo, string GameMode, struct SrvInfo, array Players)
				}
			}
		}
	}else{
		if($_debug>2) console("database.Event[$event](no ChallengeInfo !)");
	}
}

function databaseBeginChallenge_DB($response,$tm_db_n,$ChallengeInfo){
	global $_debug,$_tm_db,$_Game,$_NumberOfChecks,$_ServerOptions,$_BestChecks,$_BestPlayersChecks,$_BestChecksName,$_players;
	$tmdb =& $_tm_db[$tm_db_n];
	$tmdb['top1time'] = -1;
	
	if(!dedimaniaCheckCBerror($response,'databaseBeginChallenge_DB'))
		return;
	if($_debug>3) debugPrint("databaseBeginChallenge_DB - response",$response['Data']);

	if(isset($response['Data']['params'])){
		$tmdb['Challenge'] = $response['Data']['params'];

		//debugPrint("databaseBeginChallenge_DB:: tmdb['Challenge']: ",$tmdb['Challenge']);
		
		// forward and backward compatibility for other plugins
		if(!isset($tmdb['Challenge']['ServerMaxRank']) and isset($tmdb['Challenge']['ServerMaxRecords']))
			$tmdb['Challenge']['ServerMaxRank'] = $tmdb['Challenge']['ServerMaxRecords'];
		else if(isset($tmdb['Challenge']['ServerMaxRank']) and !isset($tmdb['Challenge']['ServerMaxRecords']))
			$tmdb['Challenge']['ServerMaxRecords'] = $tmdb['Challenge']['ServerMaxRank'];

		// if same challenge than in Results, remove Results one.
		if(isset($tmdb['Challenge']['UId']) && isset($tmdb['Results']['UId']) && $tmdb['Challenge']['UId'] == $tmdb['Results']['UId'])
			$tmdb['Results'] = array();
		
		// store old top1 time
		if(isset($tmdb['Challenge']['Records'][0]['Best']))
			$tmdb['top1time'] = $tmdb['Challenge']['Records'][0]['Best'];

		// get bestplayerschecks, make short name for records owners
		if(isset($tmdb['Challenge']['Records']) && is_array($tmdb['Challenge']['Records'])){
			foreach($tmdb['Challenge']['Records'] as $num => &$rec){
				if(!isset($rec['Game']))
					$rec['Game'] = $_Game;

				if(is_string($rec['Checks']))
					$rec['Checks'] = explode(',',$rec['Checks']);

				if(count($rec['Checks']) > 0 && end($rec['Checks']) > 0){
					// Best Checks
					if((end($rec['Checks']) == $rec['Best']) &&
						 (count($_BestChecks) <= 0 || end($rec['Checks']) < end($_BestChecks))){
						$_BestChecks = $rec['Checks'];
						$_BestChecksName = 'Top'.($tm_db_n == 0 ? '$bb0':'$b80').($num+1);
					}
					
					// Build Ideal Checks
					databaseBuildIdealChecks($rec['Checks']);
					
					// Best Player Checks
					if(!isset($_BestPlayersChecks[$rec['Login']]) || end($rec['Checks']) < end($_BestPlayersChecks[$rec['Login']]))
						$_BestPlayersChecks[$rec['Login']] = $rec['Checks'];
				}

				// make short name for record owner
				$rec['NickDraw'] = htmlspecialchars(tm_substr(stripColors($rec['NickName']),0,13),ENT_QUOTES,'UTF-8');

				//print_r($rec);
			}
		}

		// update players MaxRank
		if(isset($tmdb['Challenge']['Players']) && is_array($tmdb['Challenge']['Players'])){
			if($_debug>2) console("databaseBeginChallenge_DB({$tm_db_n}):: tmdb[Challenge][Players]: ".print_r($tmdb['Challenge']['Players'],true));
			foreach($tmdb['Challenge']['Players'] as $num => $rpl){	
				$rlogin = $rpl['Login'];
				if(!isset($tmdb['Players'][$rlogin]['MaxRank']))
					$tmdb['Players'][$rlogin] = array('Login'=>$rlogin,'MaxRank'=>$rpl['MaxRank'],'Banned'=>false,'OptionsEnabled'=>0,'Options'=>'');
				else
					$tmdb['Players'][$rlogin]['MaxRank'] = $rpl['MaxRank'];
			}
			if($_debug>1) console("databaseBeginChallenge_DB({$tm_db_n}):: tmdb[Players]: ".print_r($tmdb['Players'],true));
		}		
		
		if($_debug>2){
			$chal = $_tm_db[$tm_db_n]['Challenge'];
			$chal['Records'] = minmaxArray($chal['Records']);
			debugPrint("databaseBeginChallenge_DB:: _tm_db[$tm_db_n]['Challenge']",$chal);
		}
		//if($_debug>6) debugPrint("databaseBeginChallenge_DB - TOP1 _BestChecks",$_BestChecks);

		insertEvent('StartRace',$tm_db_n,$tmdb['Challenge'],$ChallengeInfo);
		for($i=count($tmdb['Events'])-1; $i >= 0; $i--)
			insertEventArray($tmdb['Events'][$i]);
		$tmdb['Events'] = array();
	}
}


//--------------------------------------------------------------
// BeginRound :
//--------------------------------------------------------------
function databaseBeginRound($event){
	global $_debug,$_tm_db,$database_round_time,$_currentTime;

	$database_round_time = $_currentTime;
	//console("database.Event[$event]");

	for($i=0; $i < count($_tm_db); $i++){
		$tmdb =& $_tm_db[$i];
		$tmdb['Results'] = array();
	}
}


//--------------------------------------------------------------
function database_AnnonceToDB(){
	global $_debug,$_tm_db,$_Game,$_ServerOptions,$database_ChallengeInfo,$database_GameInfos,$database_lastsent,$_currentTime,$_is_relay,$_dbmodelist;

	$database_lastsent = $_currentTime;

	if(isset($database_ChallengeInfo['UId'])){
		if($_debug>3) console("database_AnnonceToDB:: Update server DB infos.");

		$serverInfos = database_mkServerInfos();
		$votesInfo = array('UId'=>$database_ChallengeInfo['UId'],'GameMode'=>$_dbmodelist[$database_GameInfos['GameMode']]);
		$players = database_mkPlayers(true);

		for($i=0; $i < count($_tm_db); $i++){
			$tmdb = &$_tm_db[$i];
			// if database if ok
			if(isset($tmdb['XmlrpcDB']) && !$tmdb['XmlrpcDB']->isBad()){

				//debugPrint('database_AnnonceToDB - ServerOptions',$_ServerOptions);
				//debugPrint('database_AnnonceToDB - database_ChallengeInfo',$database_ChallengeInfo);
				//debugPrint('database_AnnonceToDB - database_GameInfos',$database_GameInfos);

				$callback = array('database_AnnonceToDB_DB',$i);
				$tmdb['XmlrpcDB']->addRequest($callback,
																			'dedimania.UpdateServerPlayers',$tmdb['SessionId'],
																			$serverInfos,
																			$votesInfo,
																			$players);
				// dedimania.UpdateServerPlayers(string SessionId, struct SrvInfo, struct VotesInfo, array Players)
				if($_debug>4 || ($_debug>2 && count($players) > 0)) debugPrint("database_AnnonceToDB ($i) - players",$players);
			}
		}
	}
}

function database_AnnonceToDB_DB($response,$tm_db_n){
	global $_debug,$_tm_db;

	if(!dedimaniaCheckCBerror($response,'database_AnnonceToDB_DB'))
		return;
}


//--------------------------------------------------------------
// EndRace :
//--------------------------------------------------------------
function databaseEndRace($event,$Ranking,$ChallengeInfo,$GameInfos){
	global $_debug,$_tm_db,$_Game,$_ServerOptions,$_players,$database_lastsent,$_currentTime,$_NumberOfChecks,$database_GameInfos,$database_race_time,$_is_relay,$_dbmodelist,$_client,$_GameDataDirectory,$_database_store_best_vreplay;
	if($_debug>2) console("database.Event[$event]()");

	// if relay server then just announce players (spectators), don't send final times
	if($_is_relay){
		database_AnnonceToDB();
		return;
	}

	// if race take less than 5s (script time) then don't store records at all
	// it should probably wrong because of script time sync problem with dedicated
	// or it is an immediate restart/next
	if($_currentTime - $database_race_time < 5000){
		// not enough time for records, don't store them
		return;
	}

	$database_lastsent = $_currentTime;

	//debugPrint('databaseEndRace - ServerOptions',$_ServerOptions);
	//debugPrint('databaseEndRace - ChallengeInfo',$ChallengeInfo);
	//debugPrint('databaseEndRace - GameInfos',$GameInfos);
	//if($_debug>1) debugPrint('databaseEndRace - Ranking',$Ranking);
	//if($_debug>2) debugPrint('databaseEndRace - players',$_players);

	$times = array();
	$bestchecks = array();
	$withreplay = false;
	$replays = array('VReplay'=>'','Top1GReplay'=>'','VReplayChecks'=>'');

	if($GameInfos['GameMode'] == LAPS){
		$BestTime = 'BestLapTime';
		$BestCheckpoints = 'BestLapCheckpoints';
	}else{
		$BestTime = 'BestTime';
		$BestCheckpoints = 'BestCheckpoints';
	}

	if($GameInfos['GameMode'] == CUP){
		// ignore Stunts records

	}elseif($GameInfos['GameMode'] == ROUNDS && (!isset($ChallengeInfo['LapRace']) || $ChallengeInfo['LapRace']) &&
		 isset($GameInfos['RoundsForcedLaps']) && $GameInfos['RoundsForcedLaps'] != 0){
		// special Rounds mode with forced lap on multilap map
		// just don't make the time tables in that case to not make records
		if($_debug>0) console('databaseEndRace:: RoundsForcedLaps='.$GameInfos['RoundsForcedLaps'].' so ignore records !');

	}elseif($ChallengeInfo['AuthorTime'] < 6200 && $ChallengeInfo['Author'] != 'nadeo' && $ChallengeInfo['Author'] != 'Nadeo' && $ChallengeInfo['Author'] != 'slig'){
		// only special maps under 6.2s are accepted (dedimania will not store records under 6s for them anyway)
		if($_debug>0) console('databaseEndRace:: Author time under 6.2s : records ignored !');

	}else{
		// get best times of players
		foreach($_players as $key => &$player){
			if(isset($player['Login']) && $player['Login'] == $key &&
				 isset($player['Active']) && isset($player[$BestTime]) &&
				 !is_LAN_login($player['Login']) &&
				 ($player['Active'] || $player[$BestTime] > 0)){
				
				$login = $player['Login'];

				// add time only if no inconsistency
				if(count($player[$BestCheckpoints]) > 0 && $player[$BestTime] == end($player[$BestCheckpoints])){
					if(!isset($_tm_db[0]['Players'][$login]['Banned']) || !$_tm_db[0]['Players'][$login]['Banned'])
						$times[] = array('Login'=>$login ,'Best'=>$player[$BestTime]+0,'Checks'=>implode(',',$player[$BestCheckpoints]));
					else
						console("databaseEndRace:: skip {$login}: banned on database !");
				}
			}
		}

		/*
		// create inconsistency to check database errors !!!
		if(isset($times[0]['Checks'][1])){
			$last = count($times[0]['Checks'])-1;
			$best = end($times[0]['Checks']);
			//echo "!!!!!!!!!!!!!!!!!!!!! Create inconsistency (for fake cheat tests) !!!";
			//$times[0]['Checks'][$last] += 1;
			//$times[0]['Checks'][1] = -1;
			//$times[0]['Checks'][1] = 0;
			//$times[0]['Checks'][1] = $times[0]['Checks'][0]+30;
			//$times[0]['Checks'][$last-1] = $times[0]['Checks'][$last]-100;
			//$times[0]['Checks'][$last-1] = $times[0]['Checks'][$last]-20;
			//$times[0]['Checks'][$last] = $times[0]['Checks'][$last-1]; $times[0]['Checks'][$last-1] = $best;
			//$times[0]['Checks'] = array();
			//unset($times[0]['Checks']);
			//$times[0]['Checks'] = '';
		}
		*/

		usort($times,"databaseRecCompare");
		if($_debug>=0){
			debugPrint('databaseEndRace - times',minmaxArray($times));
		}
		// get BestCheckpoints of best player
		//if(isset($times[0]['Login'])){
		//$login = $times[0]['Login'];
		//if(isset($_players[$login][$BestCheckpoints][0]) && end($_players[$login][$BestCheckpoints]) == $times[0]['Best'])
		//$bestchecks = $_players[$login][$BestCheckpoints];
		//}
		//if($_debug>2) debugPrint('databaseEndRace - bestchecks',$bestchecks);


		// get replays of best player, skip first if validation replay is not ok
		$first_time_ok = false;
		while(!$first_time_ok && count($times) > 0){

			$replays = array('VReplay'=>'','Top1GReplay'=>'','VReplayChecks'=>'');
			$login = $times[0]['Login'];

			if($times[0]['Best'] <= 0){
				// skip first time then text next first
				array_shift($times);
				continue;
			}
			
			if(!$_client->query('GetValidationReplay', $login)){
				console("databaseEndRace:: failed to get ValidationReplay of {$login} !");
				$msg = localeText(null,'server_message').localeText(null,'interact')."Failed to get validation replay for {$login},{$times[0]['Best']}, skip it...";
				// skip first time then text next first
				array_shift($times);
				continue;
			}

			$vreplay = $_client->getResponse();

			// --------------------------------------------------------------
			// sanity checks: checks against vreplay values (optionnal but better)
			$vrdata = getGbxXmlData($vreplay);

			//console("databaseEndRace:: vreplay data: ".print_r($vrdata,true));
			
			if(!$vrdata || !isset($vrdata['header']['.attr.map']['uid'])){
				console("databaseEndRace:: failed to parse VReplay !");
				$msg = localeText(null,'server_message').localeText(null,'interact')."Wrong ValidationReplay datas for {$login},{$times[0]['Best']}, skip it...";
				addCall(null,'ChatSendServerMessage', $msg);
				// skip first time then text next first
				array_shift($times);
				continue;
			}
			
			// checks VR uid
			if($vrdata['header']['.attr.map']['uid'] != $ChallengeInfo['UId']){
				console("databaseEndRace:: VReplay UId not same as current ! ({$vrdata['header']['.attr.map']['uid']},{$ChallengeInfo['UId']})");
				$msg = localeText(null,'server_message').localeText(null,'interact')."Wrong ValidationReplay UId for {$login},{$times[0]['Best']}, can't send times to database...";
				addCall(null,'ChatSendServerMessage', $msg);
				// if vreplay has bad uid then no reason to think that next will ok : send nothing
				return;
			}
			
			// If Laps mode then add full race Checkpoints of vreplay
			if($GameInfos['GameMode'] == LAPS){
				$replays['VReplayChecks'] = implode(',',$_players[$login]['BestCheckpoints']);
			}
			
			// values to checks VR time and number of checks
			$racetime = end($_players[$login]['BestCheckpoints']);
			$racenbchecks = count($_players[$login]['BestCheckpoints']);
			
			// checks VR time
			if($vrdata['header']['.attr.times']['best'] != $racetime){
				console("databaseEndRace:: VReplay time not same as current ! ({$vrdata['header']['.attr.times']['best']},{$racetime})");
				$msg = localeText(null,'server_message').localeText(null,'interact')."Wrong ValidationReplay time for {$login},{$times[0]['Best']}, skip it...";
				addCall(null,'ChatSendServerMessage', $msg);
				// skip first time then text next first
				array_shift($times);
				continue;
			}
			
			// checks VR nb of checkps
			if($vrdata['header']['.attr.checkpoints']['cur'] != $racenbchecks){
				console("databaseEndRace:: VReplay checks not same as current ! ({$vrdata['header']['.attr.checkpoints']['cur']},{$racenbchecks})");
				$msg = localeText(null,'server_message').localeText(null,'interact')."Wrong ValidationReplay checkpoints for {$login},{$times[0]['Best']}, skip it...";
				addCall(null,'ChatSendServerMessage', $msg);
				// skip first time then text next first
				array_shift($times);
				continue;
			}
			
			
			// --------------------------------------------------------------
			// add VR in datas to send
			$replays['VReplay'] = new IXR_Base64($vreplay);
			
			// --------------------------------------------------------------
			// add GR in datas to send if supposed top1
			if($_tm_db[0]['top1time'] <= 0 || $times[0]['Best'] < $_tm_db[0]['top1time']){
				// if better than old top1, then get and send ghost replay of new one

				$rfile = sprintf('replay.%s.%d.%07d.%s.Replay.Gbx',$ChallengeInfo['UId'],$GameInfos['GameMode'],$times[0]['Best'],$login);
				if(!$_client->query('SaveBestGhostsReplay', $times[0]['Login'], 'dm.top1/'.$rfile)){
					console("databaseEndRace:: failed to store GhostReplay for {$login},{$times[0]['Best']} !");
					$msg = localeText(null,'server_message').localeText(null,'interact')."Failed to save ghost replay for {$login},{$times[0]['Best']}, skip it...";
					addCall(null,'ChatSendServerMessage', $msg);
					// skip first time then text next first
					array_shift($times);
					continue;
				}

				// read top1 replay file then add it in data to send
				if(isset($_tm_db[0]['Top1ReplayUrl'])){
					// try to get the replay file from web !  this is a fallback mode for Fast remote use and should be avoided !
					// this mean that Top1ReplayUrl must be the url to get files in UserData/Replays/dm.top1/ of the dedicated
					$webrfile = "{$_tm_db[0]['Top1ReplayUrl']}/{$rfile}";
					console("databaseEndRace:: GhostReplay dm.top1/{$rfile} stored... try get {$webrfile} !");
					if($greplay = file_get_contents($webrfile)){
						$replays['Top1GReplay'] = new IXR_Base64($greplay);
						$withreplay = true;

					}else{
						console("databaseEndRace:: failed to read on web: {$webrfile} for {$login},{$times[0]['Best']} !!!");
						$msg = localeText(null,'server_message').localeText(null,'interact')."Failed to read ghost replay for {$login},{$times[0]['Best']}, can't send times to database...";
						addCall(null,'ChatSendServerMessage', $msg);
						// if can't read the GhostReaply file then no reason to think that next will be able to : send nothing
						return;
					}

				}else{
					// read the ghost replay file locally
					$frfile = "{$_GameDataDirectory}Replays/dm.top1/{$rfile}";
					console("databaseEndRace:: GhostReplay dm.top1/{$rfile} stored... try get {$frfile} !");
					if($greplay = file_get_contents($frfile)){
						$replays['Top1GReplay'] = new IXR_Base64($greplay);
						$withreplay = true;
						
					}else{
						console("databaseEndRace:: failed to read locally: {$frfile} for {$login},{$times[0]['Best']} !!!");
						$msg = localeText(null,'server_message').localeText(null,'interact')."Failed to read ghost replay for {$login},{$times[0]['Best']}, can't send times to database...";
						addCall(null,'ChatSendServerMessage', $msg);
						// if can't read the GhostReaply file then no reason to think that next will be able to : send nothing
						return;
					}
				}
			}

			// --------------------------------------------------------------
			// store VR locally if asked
			if($_database_store_best_vreplay){
				if(!file_exists('VReplays'))
					@mkdir('VReplays');
				$vrfile = sprintf('VReplays/vreplay.%s.%d.%07d.%s.Replay.Gbx',$ChallengeInfo['UId'],$GameInfos['GameMode'],$times[0]['Best'],$login);
				@file_put_contents($vrfile,$vreplay);
				console("databaseEndRace:: ValidationReplay {$vrfile} stored ({$login},{$times[0]['Best']}) !");
			}

			// --------------------------------------------------------------
			// all was ok
			$first_time_ok = true;
		}
	}

	// send times etc.
	if(isset($ChallengeInfo['UId'])){
		if($_debug>2) console("database.Event[$event]({$ChallengeInfo['UId']},'".stripColors($ChallengeInfo['Name'])."',{$ChallengeInfo['Environnement']},{$ChallengeInfo['Author']})");

		for($i=0; $i < count($_tm_db); $i++){
			$tmdb =& $_tm_db[$i];
			// if database if ok
			if(isset($tmdb['XmlrpcDB']) && !$tmdb['XmlrpcDB']->isBad()){
				
				//$msg = localeText(null,'server_message').localeText(null,'interact')." Send times to {$tmdb['Name']}...";
				//addCall(null,'ChatSendServerMessage', $msg);

				if($withreplay){
					$msg = localeText(null,'server_message').localeText(null,'interact')." Send times and Top1 replay to {$tmdb['Name']}...";
					addCall(null,'ChatSendServerMessage', $msg);
				}

				if(count($times) > 0)
					$tmdb['Waitreply'] = true;
				if($_debug>0) console("databaseEndRace($i):: send");

				$callback = array('databaseEndRace_DB',$i,$ChallengeInfo,count($times),$withreplay); 
				$tmdb['XmlrpcDB']->addRequest($callback, 
																			'dedimania.SetChallengeTimes',$tmdb['SessionId'],
																			array('UId'=>$ChallengeInfo['UId'],
																							'Name'=>tm_substr($ChallengeInfo['Name']),
																							'Environment'=>$ChallengeInfo['Environnement'],
																							'Author'=>tm_substr($ChallengeInfo['Author']),
																							'NbCheckpoints'=>$ChallengeInfo['NbCheckpoints'],
																							'NbLaps'=>$ChallengeInfo['NbLaps']),
																			$_dbmodelist[$GameInfos['GameMode']],
																			$times,
																			$replays);
			}
		}
	}
}

function databaseEndRace_DB($response,$tm_db_n,$ChallengeInfo,$nbtimes,$withreplay=false){
	global $_debug,$_tm_db,$_players,$_Game;
	$tmdb =& $_tm_db[$tm_db_n];
	$tmdb['Waitreply'] = false;
	if(!dedimaniaCheckCBerror($response,'databaseEndRace_DB'))
		return;

	if($_debug>0) console("databaseEndRace_DB($tm_db_n,$nbtimes,$withreplay)::");
	if($_debug>6) debugPrint("databaseEndRace_DB - response ($tm_db_n)",$response['Data']);

	if(isset($response['Data']['params'])){
		$tmdb['Results'] = $response['Data']['params'];

		if($nbtimes > 0){
			if($withreplay)
				$msg = localeText(null,'server_message').$tmdb['Name'].localeText(null,'interact')." : times and Top1 replay sent.";
			else
				$msg = localeText(null,'server_message').$tmdb['Name'].localeText(null,'interact')." : times sent.";
			addCall(null,'ChatSendServerMessage', $msg);
		}

		if($_debug>4) debugPrint("databaseEndRace_DB:: tmdb['Results']: ",$tmdb['Results']);

		if(isset($tmdb['Results']['Records'])){
			// make short name for records owners
			foreach($tmdb['Results']['Records'] as &$rec){
				// make short name for record owner
				$rec['NickDraw'] = htmlspecialchars(tm_substr(stripColors($rec['NickName']),0,13),ENT_QUOTES,'UTF-8');
				if(!isset($rec['Game']))
					$rec['Game'] = $_Game;
				if(is_string($rec['Checks']))
					$rec['Checks'] = explode(',',$rec['Checks']);
			}
		}

		if($_debug>2){
			$chal = $_tm_db[$tm_db_n]['Results'];
			$chal['Records'] = minmaxArray($chal['Records']);
			debugPrint("databaseEndRace_DB - _tm_db[$tm_db_n]['Challenge']",$chal);
		}

		insertEvent('FinishRace',$tm_db_n,$tmdb['Results'],$ChallengeInfo);
	}
}


// -----------------------------------
// at end of podium, wait database response up to 30s (can be long with the top1 ghost replay upload)...
function databaseEndPodium($event,$delay,$time){
	global $_debug,$_tm_db;
	if($_debug>0) console("database.Event[$event]($delay,$time)");

	if($delay >= 0 && $delay < 30000){
		$waitmore = false;
		// check if nothing to wait, else add more delay...
		for($i=0; $i < count($_tm_db); $i++){
			if($_tm_db[$i]['Waitreply'])
				$waitmore = true;
		}

		if($waitmore){
			// have to wait more...
			if($delay == 0){
				// message at beginning of wait
				$msg = localeText(null,'server_message').localeText(null,'interact')." Wait records database reply...";
				addCall(null,'ChatSendServerMessage', $msg);
			}
			delayTransition(2000); // wait 2s more

		}else{
			for($i=0; $i < count($_tm_db); $i++)
				$_tm_db[$i]['Waitreply'] = false;
		}
	}
}


// -----------------------------------
// compare function for usort, return -1 if $a should be before $b
function databaseRecCompare($a, $b)
{
	global $_players;
	// no best valid, use rank
	if($a['Best'] <= 0 && $b['Best'] <= 0)
		return ($_players[$a['Login']]['Rank'] < $_players[$b['Login']]['Rank']) ?  -1 : 1;
	// one best valid
	elseif($b['Best'] <= 0)
		return -1;
	// other best valid
	elseif($a['Best'] <= 0)
		return 1;
	// best a better than best b
	elseif($a['Best'] < $b['Best'])
		return -1;
	// best b better than best a
	elseif($a['Best'] > $b['Best'])
		return 1;
	// same best, use rank
	else
		return ($_players[$a['Login']]['BestDate'] < $_players[$b['Login']]['BestDate']) ?  -1 : 1;
}



//--------------------------------------------------------------
// PlayerBest :
//--------------------------------------------------------------
function databasePlayerBest($event,$login,$time,$ChallengeInfo,$GameInfos,$checkpts){
	global $_debug,$_tm_db,$_Game,$_players,$_BestChecks,$_BestChecksName,$_BestPlayersChecks,$database_GameInfos,$_currentTime,$database_round_time;
  if(!is_string($login))
    $login = ''.$login;
	if($_debug>0) console("database.Event[$event]('$login',$time)");

	if($database_GameInfos['GameMode'] != $GameInfos['GameMode']){
		// not same game mode in database and best infos
		return;
	}

	if($GameInfos['GameMode'] == STUNTS){
		// no records in Stunts
		return;
	}

	if($time <= 0 || is_LAN_login($login)){
		// no time or LAN login: don't make record
		return;
	}

	for($tm_db_n = 0; $tm_db_n < count($_tm_db); $tm_db_n++){
		$tmdb =& $_tm_db[$tm_db_n];
		// if database if ok
		if(isset($tmdb['XmlrpcDB']) && !$tmdb['XmlrpcDB']->isBad()){

			if(!isset($tmdb['Challenge']['UId'])){
				// can't handle the best now, put in in the specific event table
				$tmdb['Events'][] = func_get_args();

			}elseif($tmdb['Challenge']['UId'] == $ChallengeInfo['UId']){
				// if it's the same challenge uid, insert the best in records if needed
				$records = &$_tm_db[$tm_db_n]['Challenge']['Records'];

				// get best maxrank of server, player and current record if exists
				$max_record = count($records);
				$old_rank = -1;
				$old_best = -1;
				$current_record = $max_record;
				$maxrank = $tmdb['Challenge']['ServerMaxRank']+0;
				if(isset($tmdb['Players'][$login]['MaxRank']) && $tmdb['Players'][$login]['MaxRank'] > $maxrank)
					$maxrank = $tmdb['Players'][$login]['MaxRank']+0;

				// search old record
				for($j=0; $j < $max_record && ($records[$j]['Login'] != $login || $records[$j]['Game'] != $_Game);$j++)
					;
				if($j < $max_record){
					// found old record
					if($records[$j]['Best'] < $time){
						// worse than old player record
						continue;
					}
					$old_rank = $j+1;
					$old_best = $records[$j]['Best'];
					$current_record = $j;
					if(isset($records[$j]['MaxRank']) && $records[$j]['MaxRank'] > $maxrank)
						$maxrank = $records[$j]['MaxRank'];
				}

				// search for 1st worse record
				for($j = 0; ($j < $current_record) && ($time >= $records[$j]['Best']); $j++)
					;
				if($_debug>4) debugPrint("databasePlayerBest - records($login,$time,$j)",$records);

				if($j < $maxrank){
					// rec is new or better, and ok
					$new_record = $j;

					if($_debug>3) console("databasePlayerBest:: records before insert $login,$time ($current_record => $new_record, $max_record): ".print_r($records,true));
				
					if(isset($tmdb['Players'][$login]['Banned']) && $tmdb['Players'][$login]['Banned']){
						// player is banned on that database
						$msg = localeText(null,'server_message')."Record not stored ($login,$time): you are banned on {$tmdb['Name']} !";
						addCall(null,'ChatSendServerMessageToLogin', $msg, $login);
						continue;
					}

					if(end($checkpts) != $time){
						// checkpts inconsistency: don't make record
						$msg = localeText(null,'server_message')."Record not stored ($login,$time): checkpoints inconsitency !";
						addCall(null,'ChatSendServerMessageToLogin', $msg, $login);
						return;
					}

					// verify that the time is potentially valid and that the script time is not wrong
					$cpdelay = ($_currentTime - $database_round_time) - $time;
					if($cpdelay < 0){ 
						// something is bad with times : don't store record !
						if($_debug>0) console("Wrong record($login,$time,$j): player should have started before the round !\n(can be an anormal script timeout which made it)");
						$msg = localeText(null,'server_message')."Record not stored ($login,$time): wrong times or script time sync problem !";
						addCall(null,'ChatSendServerMessageToLogin', $msg, $login);
						return;
					}

					// shift right records from $new_record to $current_record
					for($j = $current_record; $j > $new_record; $j--){
						$records[$j] = $records[$j-1];
						$records[$j]['Rank'] = $j+1;
					}

					// if new then update $max_record (else the number of records stay the same)
					if($current_record >= $max_record)
						$max_record++;

					// set new rec
					$records[$new_record] = array('Game'=>$_Game,'Login'=>$login,'NickName'=>tm_substr($_players[$login]['NickName']),'Best'=>$time,'Rank'=>$new_record+1,'NewBest'=>true,'NickDraw'=>$_players[$login]['NickDraw'],'Checks'=>$checkpts,'MaxRank'=>$maxrank);

					insertEvent('PlayerRecord',$tm_db_n,$login,$time,$new_record+1,$old_best,$old_rank,$ChallengeInfo,$GameInfos,$checkpts);

					// check if other records below $new_record should disapear because above MaxRank
					// note that ServerMaxRank is not considered here : only new or improved records use it if above player and record ones.
					$j = $new_record+1;
					while($j < $max_record){
						if($records[$j]['Rank'] > $records[$j]['MaxRank']){
							// record above its MaxRank, remove it by shifting left those above
							$rlogin = $records[$j]['Login'];
							if($_debug>1) console("databasePlayerBest:: record #{$records[$j]['Rank']} from {$rlogin} is above its MaxRank ({$records[$j]['MaxRank']}): remove it");
							if(isset($_players[$rlogin]['Active']) && $_players[$rlogin]['Active']){
								$msg = localeText(null,'server_message')."Your record #{$records[$j]['Rank']} was deleted: above its MaxRank ({$records[$j]['MaxRank']}) !";
								addCall(null,'ChatSendServerMessageToLogin', $msg, $rlogin);
							}
							$max_record--;
							for($k = $j; $k < $max_record; $k++){
								$records[$k] = $records[$k+1];
								$records[$k]['Rank'] = $k+1;
							}
							if(isset($records[$max_record]))
								unset($records[$max_record]);
							
						}else{
							$j++;
						}
					}

					if($_debug>2) console("databasePlayerBest:: records after insert $login,$time ($current_record => $new_record, $max_record): ".print_r($records,true));

					// update _BestChecks array
					if($new_record == 0 && (count($_BestChecks) <= 0 || end($_BestChecks) > $time)){
						$b = (count($_BestChecks) <= 0) ? 0 : $j;
						$_BestChecks = $checkpts;
						$_BestChecksName = 'Top'.($tm_db_n == 0 ? '$bb0':'$b80').($b+1);
						if($_debug>3) debugPrint("BestChecks taken by $login for record :",$time);
					}

				}
			}
		}
	}

	if(count($checkpts) > 0 && $time > 0 && end($checkpts) == $time &&
		 (!isset($_BestPlayersChecks[$login]) || $time < end($_BestPlayersChecks[$login]))){
		$_BestPlayersChecks[$login] = $checkpts;
		databaseBuildIdealChecks($_BestPlayersChecks[$login]);
	}
	
	//if($_debug>3) debugPrint("databasePlayerBest - records - 3 ($login,$time)",$records);
}


//--------------------------------------------------------------
// Build ideal checks array : $_IdealChecks[$cp][$cp] is supposed best time at checkpoint $cp
//--------------------------------------------------------------
function databaseBuildIdealChecks(&$checks){
	global $_debug,$_IdealChecks;
	foreach($checks as $num => $time){
		if($num > 0){
			if(!isset($_IdealChecks[$num-1][$num]) || ($time < $_IdealChecks[$num-1][$num]) ||
				 (($time == $_IdealChecks[$num-1][$num]) && $checks[$num-1] < $_IdealChecks[$num-1][$num-1])){
				$_IdealChecks[$num-1] = $checks;
				$_IdealChecks[-1][$num-1] = $checks[$num-1];
			}
		}
	}
	if(!isset($_IdealChecks[$num][$num]) || ($time < $_IdealChecks[$num][$num])){
		$_IdealChecks[$num] = $checks;
		$_IdealChecks[-1][$num] = $checks[$num];
	}
	if($_debug>3) console('NewChecks: '.implode(',',$checks));
	if($_debug>3) console('IdealChecks: '.implode(',',$_IdealChecks[-1]));
	if($_debug>4) debugPrint('databaseBuildIdealChecks - _IdealChecks (full) ',$_IdealChecks);
}



//--------------------------------------------------------------
function database_mkPlayers($with_votes=false){
	global $_debug,$_players;

	$players = array();
	foreach($_players as $login => &$pl){
		if(!$pl['Relayed']){
			$pinfo = database_mkPlayerInfo($login,true,$with_votes);
			if($pinfo !== false){
				$players[] = $pinfo;
			}
		}
	}
	return $players;
}


//--------------------------------------------------------------
function database_mkPlayerInfo($login,$short=false,$with_vote=false){
	global $_Game,$_players;
  if(!is_string($login))
    $login = ''.$login;

	if(isset($_players[$login]['Login']) &&  $_players[$login]['Login'] == $login &&
		 isset($_players[$login]['Active']) && $_players[$login]['Active'] &&
		 !$_players[$login]['Relayed'] && !is_LAN_login($login)){

		$player = &$_players[$login];
		$nickname = tm_substr($player['NickName'],0,100);
		$path = isset($player['Path']) ? tm_substr($player['Path'],0,100) : '';
		$isspec = isset($player['IsSpectator']) ? $player['IsSpectator'] : false;
		$vote = -1; // todo : set the right value

		if($short && !$with_vote)
			return array('Login'=>$login,'IsSpec'=>$isspec);
		else if($short)
			return array('Login'=>$login,'IsSpec'=>$isspec,'Vote'=>$vote);
		else
			return array('Login'=>$login,'NickName'=>$nickname,'Path'=>$path,'IsSpec'=>$isspec,'Vote'=>$vote);
	}
	return false;
}


//------------------------------------------
// build server infos :
//------------------------------------------
function database_mkServerInfos(){
	global $_debug,$_ServerOptions,$_ChallengeList,$_CurrentChallengeIndex,$_PlayerList,$_DedConfig;
	
	// compute number of players and specs
	$numplayers = 0;
	$numspecs = 0;
	foreach($_PlayerList as &$pl){
		if(($pl['SpectatorStatus']%10) > 0)
			$numspecs++;
		else
			$numplayers++;
	}

  $serverInfos = array('SrvName'=>tm_substr($_ServerOptions['Name']),
											 'Comment'=>tm_substr($_ServerOptions['Comment']),
											 'Private'=>($_ServerOptions['Password'] != ''),
											 'NumPlayers'=>$numplayers,
											 'MaxPlayers'=>$_ServerOptions['CurrentMaxPlayers'],
											 'NumSpecs'=>$numspecs,
											 'MaxSpecs'=>$_ServerOptions['CurrentMaxSpectators'],
											 );
	//if($_debug>2) debugPrint('database_mkServerInfos - serverInfos',$serverInfos);
	return $serverInfos;
}



function dedimaniaCheckCBerror($response,$funcname=''){
	// show dedimania warning
	if(isset($response['Data']['errors']) && is_string($response['Data']['errors']) && strlen($response['Data']['errors']) > 0)
		console("\n*********** dedimaniaCheckCBerror({$funcname})::WARNING:\n{$response['Data']['errors']}\n***********");

	// if response value then "ok" (else it was an error, not a warning)
	if(isset($response['Data']['params']))
		return true;

	// show webaccess connection error
	if(isset($response['Error']) && is_string($response['Error']) && strlen($response['Error']) > 0)
		console("\n*********** dedimaniaCheckCBerror({$funcname})::Webaccess connection error:\n{$response['Error']}\n***********");

	print_r($response);
	return false;
}
	

function databaseIsError(&$error){
	if(is_string($error) && strlen($error) > 0)
		return true;
	if(is_array($error) && count($error) > 0)
		return true;
	return false;
}



// -----------------------------------------------------------
// -------------------- CHAT COMMAND -------------------------
// -----------------------------------------------------------


// checks
function chat_cp($author, $login, $params){
	global $_debug,$_Game,$_players,$_tm_db,$_BestChecks,$_BestChecksName,$_IdealChecks,$_BestPlayersChecks;
	
	$msg = localeText(null,'server_message').localeText(null,'interact')."/cp [-d] ideal|best|1|2|etc. : select the checkpoints list used for live time gaps (-d to show in chat the time between cps).";
	$showdiff = false;
	if(isset($params[0]) && ($params[0] == '-d' || $params[0] == '-diff')){
		array_shift($params);
		$showdiff = true;
	}
	if(isset($params[0]) && isset($_players[$login]['ChecksGaps'])){
		if($params[0] == 'ideal'){
			$_players[$login]['ChecksGaps'] = 'ideal';
			$msg = localeText(null,'server_message').localeText(null,'interact').'Set to ideal checkpoints times.';
			$msg .= "\nNote: it is done taking for each checkpoint the time of the top which had the best time on next checkpoint, and so is potentially a time for a best way to next checkpoint. Strangely you will probably have some time worse than on a specific top.";

		}elseif($params[0] == 'best' || $params[0] == '0'){
			$_players[$login]['ChecksGaps'] = 'best';
			$msg = localeText(null,'server_message').localeText(null,'interact').'Set to best top checkpoints times.';

		}elseif(is_numeric($params[0])){
			if(isset($_tm_db[0]['Challenge']['Records'][$params[0]-1]['Checks']) &&
				 count($_tm_db[0]['Challenge']['Records'][$params[0]-1]['Checks']) > 0){
				$_players[$login]['ChecksGaps'] = $_tm_db[0]['Challenge']['Records'][$params[0]-1]['Checks'];
				$_players[$login]['ChecksGaps']['Name'] = 'Top$bb0'.$params[0];
				$msg = localeText(null,'server_message').localeText(null,'interact').'Set to main Top'.$params[0].'.';

			}elseif(isset($_tm_db[1]['Challenge']['Records'][$params[0]-1]['Checks']) &&
							count($_tm_db[1]['Challenge']['Records'][$params[0]-1]['Checks']) > 0){
				$_players[$login]['ChecksGaps'] = $_tm_db[1]['Challenge']['Records'][$params[0]-1]['Checks'];
				$_players[$login]['ChecksGaps']['Name'] = 'Top$b80'.$params[0];
				$msg = localeText(null,'server_message').localeText(null,'interact').'Set to secondary Top'.$params[0].'.';

			}elseif(isset($_tm_db[2]['Challenge']['Records'][$params[0]-1]['Checks']) &&
							count($_tm_db[2]['Challenge']['Records'][$params[0]-1]['Checks']) > 0){
				$_players[$login]['ChecksGaps'] = $_tm_db[2]['Challenge']['Records'][$params[0]-1]['Checks'];
				$_players[$login]['ChecksGaps']['Name'] = 'Top$b40'.$params[0];
				$msg = localeText(null,'server_message').localeText(null,'interact').'Set to secondary Top'.$params[0].'.';

			}else{
				$msg .= "\nInvalid top value.";
			}
		}

	}
	if(is_array($_players[$login]['ChecksGaps'])){
		$cps = $_players[$login]['ChecksGaps'];
		$cpsname = '.';
	}elseif($_players[$login]['ChecksGaps'] == 'ideal'){
		$cps = $_IdealChecks[-1];
		$cpsname = ',Ideal.';
	}else{
		$cps = $_BestChecks;
		$cpsname = ','.$_BestChecksName.'.';
	}
	if($showdiff){
		$msg .= "\nValue(cp gaps): ";
		$sep = '$n';
		$prev0 = 0;
		$prev1 = 0;
		foreach($cps as $i => $val){
			$diff0 = $val - $prev0;
			$prev0 = $val;
			if(!is_numeric($i)){
				$msg .= $sep.$val;
			}elseif(!isset($_BestPlayersChecks[$login][$i])){
				$msg .= $sep.'$666'.($i+1).':$dcf'.MwTimeToString2($diff0);
			}elseif(is_numeric($i)){
				$diff1 = $_BestPlayersChecks[$login][$i] - $prev1;
				$prev1 = $_BestPlayersChecks[$login][$i];
				
				$diff = $diff1 - $diff0;
				if($diff > 0)
					$msg .= $sep.'$666'.($i+1).':$dcf'.MwTimeToString2($diff0).'($e11'.MwDiffTimeToString($diff).'$dcf)';
				else
					$msg .= $sep.'$666'.($i+1).':$dcf'.MwTimeToString2($diff0).'($11e'.MwDiffTimeToString($diff).'$dcf)';
			}
			$sep = ',';
		}
	}else{
		$msg .= "\nValue: ";
		$sep = '$n';
		foreach($cps as $i => $val){
			
			if(!is_numeric($i)){
				$msg .= $sep.$val;
			}elseif(!isset($_BestPlayersChecks[$login][$i])){
				$msg .= $sep.'$666'.($i+1).':$dcf'.MwTimeToString2($val);
			}else{
				$diff = $_BestPlayersChecks[$login][$i] - $val;
				if($diff > 0)
					$msg .= $sep.'$666'.($i+1).':$dcf'.MwTimeToString2($val).'($e11'.MwDiffTimeToString($diff).'$dcf)';
				else
					$msg .= $sep.'$666'.($i+1).':$dcf'.MwTimeToString2($val).'($11e'.MwDiffTimeToString($diff).'$dcf)';
			}
			$sep = ',';
		}
	}
	$msg .= $cpsname;
	addCall(null,'ChatSendToLogin', $msg, $login);
}



?>